(* ::Package:: *)

subtotran = {xxx:(\[Eta]$ | \[Eta]$b | \[Eta]0$ | \[Eta]0$b | \[Zeta]$)[a__][_] :> tran^Total[{a}]*xxx, \[ScriptU]$[a_][r_] :> \[ScriptU]$[a][r]/tran, g -> g/tran,Im1->Im1 tran^5,Im2->Im2 tran^7,Im3->Im3 tran^9,Im4->Im4 tran^11}; 


FindTranOrder = With[{tmp = If[FreeQ[#1, tran], #1 /. subtotran, #1]}, StringJoin["tran order = ", ToString[Exponent[tmp, tran]]]] & ; 
FindHighTranCoef = With[{tmp = If[FreeQ[#1, tran], #1 /. subtotran, #1]}, Coefficient[tmp, tran, Exponent[tmp, tran]]] & ; 


tranpowers = {xxx:comb1 | comb2 | q$[3, 4][_] | q$b[3, 4][_] | U$b[0]^2 | q$[1, 3][_] | q$b[1, 3][_] :> xxx/tran^2, xxx:OverBar[\[Alpha]] | \[Alpha] :> xxx/tran^4, 
    xxx:q$[1, 4][_] | q$b[1, 4][_] :> xxx/tran, xxx:q$[2][_] | q$b[2][_] :> tran*xxx}; 
subcomb = {comb1 -> -((-q$[2, 4][1])*q$b[1, 3][-1] - 2*q$[1, 4][1]*q$b[1, 4][-1] - q$[1, 3][1]*q$b[2, 4][-1]), 
    comb2 -> (-U$b[0]^2)*(-q$[2, 4][1] - 2*q$[1, 4][1]*q$b[2][0] - q$[1, 3][1]*q$b[2][0]^2)}; 


leadingtranexplicit = {U$[0]^2 -> -((2*g^2)/x$h[0]^2), U$[0] -> ((I*Sqrt[2])/x$h[0])*g, q$[2][0] -> -I/(3*g*x$h[0]), q$[1, 3][0] -> -18*g^2*Q$[0]*\[Eta]$h[2][1], 
    q$[1, 4][0] -> 6*I*g*Q$[0]*\[Eta]$h[3][1], q$[2, 4][0] -> 2*Q$[0]*\[Eta]$h[4][1]}; 
leadingtran = {xxx:U$b[_]^2 | U$b[_] | q$b[2][_] | q$b[_, _][_] :> (xxx /. mconj /. leadingtran /. mconj), 
    xxx:U$[r_]^2 | U$[r_] | q$[2][r_] | q$[_, _][r_] :> (xxx /. Shift[-r] /. leadingtranexplicit /. Shift[r] /. u -> u + (I*r)/2)}; 


(* ::Text:: *)
(*subtoBes1 transforms xh with nontrivial measure: ((1/*)
(*\!\(\*OverscriptBox[*)
(*StyleBox["x",*)
(*FontColor->RGBColor[0, 0.6, 0]], *)
(*StyleBox["^",*)
(*FontColor->RGBColor[0, 0.6, 0]]]\)+*)
(*\!\(\*OverscriptBox[*)
(*StyleBox["x",*)
(*FontColor->RGBColor[0, 0.6, 0]], *)
(*StyleBox["^",*)
(*FontColor->RGBColor[0, 0.6, 0]]]\))/(-(1/*)
(*\!\(\*OverscriptBox[*)
(*StyleBox["x",*)
(*FontColor->RGBColor[0, 0.6, 0]], *)
(*StyleBox["^",*)
(*FontColor->RGBColor[0, 0.6, 0]]]\))+*)
(*\!\(\*OverscriptBox[*)
(*StyleBox["x",*)
(*FontColor->RGBColor[0, 0.6, 0]], *)
(*StyleBox["^",*)
(*FontColor->RGBColor[0, 0.6, 0]]]\))) 1/*)
(*\!\(\*OverscriptBox[*)
(*StyleBox["x",*)
(*FontColor->RGBColor[0, 0.6, 0]], *)
(*StyleBox["^",*)
(*FontColor->RGBColor[0, 0.6, 0]]]\)^a*)
(*subtoBes2 transforms xh with trivial measure 1/*)
(*\!\(\*OverscriptBox[*)
(*StyleBox["x",*)
(*FontColor->RGBColor[0, 0.6, 0]], *)
(*StyleBox["^",*)
(*FontColor->RGBColor[0, 0.6, 0]]]\)^a*)


(* ::Text:: *)
(*subtoBes1 (* this one for slightly below real axis and measure (x+1/x)/(x-1/x) in front of *)*)
(*subtoBes2 (* this one for slightly below real axis and no special measure in front of *)*)


subtoBes1 = {\[Eta]$h[a_][2] :> a*(-I)^a*(Subscript[J, a][2*g*Subscript[z, 1]]/Subscript[z, 1]), 
    \[Eta]$bh[a_][-2] :> a*I^a*(Subscript[J, a][2*g*Subscript[z, 3]]/Subscript[z, 3]), 
    x$h[0]^(a_ /; a < 0) :> D[Subscript[J, -a][2*g*Subscript[z, 2]], Subscript[z, 2]]/I^a}; 
subtoBes2 = {\[Eta]$h[a_][2] :> a*(-I)^a*(Subscript[J, a][2*g*Subscript[z, 1]]/Subscript[z, 1]), 
    \[Eta]$bh[a_][-2] :> a*I^a*(Subscript[J, a][2*g*Subscript[z, 3]]/Subscript[z, 3]), 
    x$h[0]^(a_ /; a < 0) :> ((-a)*(Subscript[J, -a][2*g*Subscript[z, 2]]/Subscript[z, 2]))/I^a}; 
subJBes={Subscript[J, a_]:>(BesselJ[a,#]&)};


sub\[Eta]h\[Eta][\[CapitalLambda]_] := {\[Eta]$h[a_][2] :> Normal@(Series[1/x$h[0]^a /. subJuk, {g, 0, \[CapitalLambda]}] /. u^(pow_ /; pow < 0) :> \[Eta]$[-pow][2]), 
    \[Eta]$bh[a_][-2] :> Normal@(Series[1/x$h[0]^a /. subJuk, {g, 0, \[CapitalLambda]}] /. u^(pow_ /; pow < 0) :> \[Eta]$b[-pow][-2])}; 
